---
type: api
title: Create a Fleet Server host
description: **Spaces method and path for this operation:**
url: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/kibana-serverless/operation/operation-post-fleet-fleet-server-hosts
resource: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/kibana-serverless/operation/operation-post-fleet-fleet-server-hosts
products:
  - Kibana
---

# Create a Fleet Server host

- Server: `https://{kibana_url}`

## Paths

- `POST` `/api/fleet/fleet_server_hosts`
- `POST` `/s/{space_id}/api/fleet/fleet_server_hosts`

- [Api key auth](/elastic/docs-builder/docs/4371/api/doc/kibana-serverless/authentication#apikeyauth)

## Description

Refer to [Spaces](https://www.elastic.co/docs/deploy-manage/manage-spaces) for more information.

Create a new Fleet Server host.<br/><br/>[Required authorization] Route required privileges: fleet-settings-all.

## Request Body

`application/json`

- `allow_edit` ([] string · max: 100) — optional
- `host_urls` ([] string · min: 1 · max: 10) — required
- `id` (string) — optional
- `is_default` (boolean · default: false) — optional
- `is_internal` (boolean) — optional
- `is_preconfigured` (boolean · default: false) — optional
- `name` (string) — required
- `proxy_id` (string) — optional — nullable
- `secrets` (object) — optional
  - `ssl` (object) — optional
    - `agent_key` (union anyOf) — optional
      - **{ id }**
        - `id` (string) — required
      - **string**
    - `es_key` (union anyOf) — optional
      - **{ id }**
        - `id` (string) — required
      - **string**
    - `key` (union anyOf) — optional
      - **{ id }**
        - `id` (string) — required
      - **string**
- `ssl` (object) — optional — nullable
  - `agent_certificate` (string) — optional
  - `agent_certificate_authorities` ([] string · max: 10) — optional
  - `agent_key` (string) — optional
  - `certificate` (string) — optional
  - `certificate_authorities` ([] string · max: 10) — optional
  - `client_auth` (enum) — optional
    Values: `optional`, `required`, `none`
  - `es_certificate` (string) — optional
  - `es_certificate_authorities` ([] string · max: 10) — optional
  - `es_key` (string) — optional
  - `key` (string) — optional

## Responses

#### `200`

Successful response

`application/json`

- `item` (object)
  - `allow_edit` ([] string · max: 100)
  - `host_urls` ([] string · min: 1 · max: 10)
  - `id` (string)
  - `is_default` (boolean · default: false)
  - `is_internal` (boolean)
  - `is_preconfigured` (boolean · default: false)
  - `name` (string)
  - `proxy_id` (string) — nullable
  - `secrets` (object)
    - `ssl` (object)
      - `agent_key` (union anyOf)
        - **{ id }**
          - `id` (string)
        - **string**
      - `es_key` (union anyOf)
        - **{ id }**
          - `id` (string)
        - **string**
      - `key` (union anyOf)
        - **{ id }**
          - `id` (string)
        - **string**
  - `ssl` (object) — nullable
    - `agent_certificate` (string)
    - `agent_certificate_authorities` ([] string · max: 10)
    - `agent_key` (string)
    - `certificate` (string)
    - `certificate_authorities` ([] string · max: 10)
    - `client_auth` (enum)
      Values: `optional`, `required`, `none`
    - `es_certificate` (string)
    - `es_certificate_authorities` ([] string · max: 10)
    - `es_key` (string)
    - `key` (string)
#### `400`

Bad Request

`application/json`

- `attributes` (object)
- `error` (string)
- `errorType` (string)
- `message` (string)
- `statusCode` (number)
## Code Examples

#### Console

```console
POST /api/fleet/fleet_server_hosts
{
  "host_urls": [
    "https://fleet-server.example.com:8220"
  ],
  "is_default": false,
  "name": "My Fleet Server"
}
```

#### curl

```curl
curl -X POST "https://{kibana_url}/api/fleet/fleet_server_hosts" \
  -H "kbn-xsrf: true" \
  -H "Content-Type: application/json" \
  -d '{
  "host_urls": [
    "https://fleet-server.example.com:8220"
  ],
  "is_default": false,
  "name": "My Fleet Server"
}'
```

## Response Examples

#### Post fleet server host

The created Fleet Server host

```json
{
  "item": {
    "host_urls": [
      "https://fleet-server.example.com:8220"
    ],
    "id": "fleet-server-host-id-2",
    "is_default": false,
    "is_preconfigured": false,
    "name": "My Fleet Server"
  }
}
```

#### Generic error response

Example of a generic error response

```json
{
  "error": "Bad Request",
  "message": "An error message describing what went wrong",
  "statusCode": 400
}
```

